# Ogre::ExternalTextureSourceManager Class Reference

Singleton Class which handles the registering and control of texture plugins. More...

`#include <OgreExternalTextureSourceManager.h>`

Inheritance diagram for Ogre::ExternalTextureSourceManager:

List of all members.

## Public Member Functions

| ExternalTextureSourceManager ()
| Constructor.
| ~ExternalTextureSourceManager ()
| Destructor.
void | setCurrentPlugIn (const String &sTexturePlugInType)
| Sets active plugin (ie.
ExternalTextureSource * | getCurrentPlugIn ()
| Returns currently selected plugin, may be null if none selected.
void | destroyAdvancedTexture (const String &sTextureName, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Calls the destroy method of all registered plugins...
ExternalTextureSource * | getExternalTextureSource (const String &sTexturePlugInType)
| Returns the plugin which reistered itself with a specific name (eg.
void | setExternalTextureSource (const String &sTexturePlugInType, ExternalTextureSource *pTextureSystem)
| Called from plugin to register itself.

## Static Public Member Functions

ExternalTextureSourceManager & | getSingleton (void)
| Override standard Singleton retrieval.
ExternalTextureSourceManager * | getSingletonPtr (void)
| Override standard Singleton retrieval.

## Protected Types

typedef std::map< String, ExternalTextureSource * > | TextureSystemList

## Protected Attributes

ExternalTextureSource * | mpCurrExternalTextureSource
TextureSystemList | mTextureSystems

## Static Protected Attributes

ExternalTextureSourceManager * | ms_Singleton

## Detailed Description

Singleton Class which handles the registering and control of texture plugins.

The plugins will be mostly controlled via a string interface.

Definition at line 46 of file OgreExternalTextureSourceManager.h.

## Member Typedef Documentation

typedef std::map< String, ExternalTextureSource*> Ogre::ExternalTextureSourceManager::TextureSystemList `[protected]`

| Definition at line 109 of file OgreExternalTextureSourceManager.h.

## Constructor & Destructor Documentation

Ogre::ExternalTextureSourceManager::ExternalTextureSourceManager | ( |  | ) |

| Constructor.

Ogre::ExternalTextureSourceManager::~ExternalTextureSourceManager | ( |  | ) |

| Destructor.

## Member Function Documentation

void Ogre::ExternalTextureSourceManager::destroyAdvancedTexture | ( | const String & | sTextureName,
|  | const String & | groupName = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME
| ) |

| Calls the destroy method of all registered plugins... Only the owner plugin should perform the destroy action.

ExternalTextureSource* Ogre::ExternalTextureSourceManager::getCurrentPlugIn | ( |  | ) |

| Returns currently selected plugin, may be null if none selected. Definition at line 58 of file OgreExternalTextureSourceManager.h.

ExternalTextureSource* Ogre::ExternalTextureSourceManager::getExternalTextureSource | ( | const String & | sTexturePlugInType | ) |

| Returns the plugin which reistered itself with a specific name (eg. "video"), or null if specified plugin not found

ExternalTextureSourceManager& Ogre::ExternalTextureSourceManager::getSingleton | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< ExternalTextureSourceManager >.

ExternalTextureSourceManager* Ogre::ExternalTextureSourceManager::getSingletonPtr | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< ExternalTextureSourceManager >.

void Ogre::ExternalTextureSourceManager::setCurrentPlugIn | ( | const String & | sTexturePlugInType | ) |

| Sets active plugin (ie. "video", "effect", "generic", etc..)

void Ogre::ExternalTextureSourceManager::setExternalTextureSource | ( | const String & | sTexturePlugInType,
|  | ExternalTextureSource * | pTextureSystem
| ) |

| Called from plugin to register itself.

## Member Data Documentation

ExternalTextureSource* Ogre::ExternalTextureSourceManager::mpCurrExternalTextureSource `[protected]`

| Definition at line 106 of file OgreExternalTextureSourceManager.h.

ExternalTextureSourceManager * Ogre::Singleton< ExternalTextureSourceManager >::ms_Singleton `[static, protected, inherited]`

| Definition at line 54 of file OgreSingleton.h.

TextureSystemList Ogre::ExternalTextureSourceManager::mTextureSystems `[protected]`

| Definition at line 110 of file OgreExternalTextureSourceManager.h.

The documentation for this class was generated from the following file:

- OgreExternalTextureSourceManager.h

Copyright © 2000-2005 by The OGRE Team
Last modified Sun Nov 20 12:36:41 2005